import { DataSource } from '@angular/cdk/table';
import { MatPaginator } from '@angular/material/paginator';
import { MatSort } from '@angular/material/sort';
import { EventEmitter } from '@angular/core';
import { TableFilter } from "@yukawa/chain-base-angular-domain";
export declare abstract class TableDataSource<E> extends DataSource<E> {
    status: 'ready' | 'loading' | 'error';
    errorEvent: EventEmitter<Error>;
    showSpinner: boolean;
    /**
     *  Called when the table is being destroyed. Use this function, to clean up
     * any open connections or free any held resources that were set up during connect.
     */
    disconnect(): void;
    /**
     * overload to provide post load filtering
     */
    protected filterData(data: E[]): E[];
    protected applyPaginator(filter: TableFilter, paginator: MatPaginator): void;
    protected applySort(filter: TableFilter, sort: MatSort): void;
    protected applyKeyword(filter: TableFilter, value?: string): void;
    protected onError(e: any, op?: string, component?: string): void;
}
